#include "Cell.h"
#include "Vertex.h"
#include "Edge.h"

template<class T>
Cell<T>::Cell(T * new_data) {
	data = new_data;
	next = NULL;
}

template<class T>
Cell<T>::~Cell(void) {
	if (data) delete data;
}

template<class T>
Cell<T> * Cell<T>::get_next(void) {
	return next;
}

template<class T>
void Cell<T>::set_next(Cell<T> * new_next) {
	next = new_next;
}

template<class T>
T * Cell<T>::remove_data(void) {
	T * send;
	send = data;
	data = NULL;
	return send;
}

template<class T>
T * Cell<T>::read_data(void) {
	return data;
}

template class Cell<char>;
template class Cell<Vertex>;
template class Cell<Edge>;
